/* 승자: o robo foda do reira =) 2.0 */

#include <cstring>
#include <vector>
#include <cstdlib>
#include <ctime>
#include <cstdio>
#include <queue>
#include <iostream>
#include <cmath>
#include "Const.h"

#define max(a, b) ( a > b ? a : b)

using namespace std;

typedef pair<int, int> ii;

typedef struct {
    int x, y;
    int tontura;
    bool empe;
    char mao;
} cri;

int dx[] = {1,1,-1,-1,-2,2,0,0, -1,1,0,0};
int dy[] = {1,-1,1,-1,0,0,-2,2, 0,0,-1,1};

cri bonecomal[TAM*TAM+3];
int nboqs;
int antivini[TIME];
int antivininow[TIME];
int score[2];
int altura[TAM][TAM];
char campo[TAM][TAM];
bool podepegar[TAM][TAM];
cri crianca[2*TIME];
char movimento[TIME][32];
bool forcapoe[TIME];

// <commom>

inline int abs(int n) {
    return (n >= 0 ? n : -n);
}

inline int javaround(double a) {
    return (int)floor(a + 0.5);
}

inline int rounde(double x) {
    if (x < 0.0) {
        return (int)-javaround( -x);
    }
    return (int)javaround(x);
}

// </commom>

bool c_livre(int i, int j) {
    if (campo[i][j] != C_VAZIO and campo[i][j] != SEILA ) return false;
    for (int c=0;c<2*TIME;c++)
        if (crianca[c].x == i and crianca[c].y == j) return false;
    return true;
}



bool caminho_livre(int x1, int y1, int x2, int y2) {
    int n = max(abs(x2-x1), abs(y2-y1));
    for (int t=1;t<=n;t++) {
        int x = x1 + rounde((double)(t*(x2 - x1))/(double)n);
        int y = y1 + rounde((double)(t*(y2 - y1))/(double)n);
        if ((x == x2 and y == y2) or (x == x1 and y == y1)) continue;
        if (!c_livre(x,y)) return false;
    }
    return true;
}

bool meiolivre(int cx, int cy, int dx, int dy) {
    if (cx == dx and cy == dy-2 and !c_livre(cx,dy-1)) return false;
    if (cx == dx and cy == dy+2 and !c_livre(cx,dy+1)) return false;
    if (cy == dy and cx == dx-2 and !c_livre(dx-1,cy)) return false;
    if (cy == dy and cx == dx+2 and !c_livre(dx+1,cy)) return false;
    return true;
}

bool territorio_inimigo(int x, int y) {
    for (int i=TIME;i<2*TIME;i++) if (crianca[i].x != SEILA) {
        int dist2 = (crianca[i].x - x)*(crianca[i].x - x) + (crianca[i].y-y)*(crianca[i].y-y);
        if (dist2 < 8*8) return true;
    }
    return false;

}

bool corre(int c, int x, int y) {

    int comeco = crianca[c].empe ? 0 : 8;
    bool enfilered[TAM][TAM];
    queue<ii> Q;
    while (!Q.empty()) Q.pop();
    ii pai[TAM][TAM];
    memset(enfilered,false,sizeof(enfilered));
    Q.push(ii(crianca[c].x,crianca[c].y));
    enfilered[crianca[c].x][crianca[c].y] = true;
    pai[crianca[c].x][crianca[c].y] = ii(crianca[c].x, crianca[c].y);
    while (!Q.empty()) {
        ii u = Q.front(); Q.pop();
        for (int i=comeco;i<12;i++) {
            if (0 <= u.first+dx[i] and u.first+dx[i] < TAM and 0 <= u.second+dy[i] and u.second+dy[i] < TAM)
            if (!enfilered[u.first+dx[i]][u.second+dy[i]] and (c_livre(u.first+dx[i],u.second+dy[i]) or (u.first+dx[i] == x and u.second+dy[i] == y))) {
                if (i < 8 and !meiolivre(crianca[c].x,crianca[c].y,u.first+dx[i],u.second+dy[i])) continue;
                Q.push(ii(u.first+dx[i],u.second+dy[i]));
                enfilered[u.first+dx[i]][u.second+dy[i]] = true;
                pai[u.first+dx[i]][u.second+dy[i]] = u;
                if (u.first+dx[i] == x and u.second+dy[i] == y) {
                    goto tt;
                }
            }
        }
    }
    return false;
tt:
    ii u = ii(x,y);
    while (pai[pai[u.first][u.second].first][pai[u.first][u.second].second] != pai[u.first][u.second]) {
        u = pai[u.first][u.second];
    }
    sprintf(movimento[c],"%s %d %d\n",crianca[c].empe ? "run" : "crawl", u.first,u.second);
    crianca[c].x = u.first;
    crianca[c].y = u.second;
    return true;
}

bool peganevesolta(int c) {
    int dx[] = {-1,0,1};
    int dy[] = {-1,0,1};
    for (int i=0;i<3;i++)
    for (int j=0;j<3;j++) if (podepegar[crianca[c].x+dx[i]][crianca[c].y+dy[j]])
    if (altura[crianca[c].x+dx[i]][crianca[c].y+dy[j]] > 0 and c_livre(crianca[c].x+dx[i],crianca[c].y+dy[j])) {
            sprintf(movimento[c],"pickup %d %d\n",crianca[c].x+dx[i],crianca[c].y+dy[j]);
            podepegar[crianca[c].x+dx[i]][crianca[c].y+dy[j]] = false;
            return true;
    }

    return corre(c,rand()%31,rand()%31);
}


bool largamao(int c) {
    int dx[] = {-1,0,1};
    int dy[] = {-1,0,1};
    for (int i=0;i<3;i++)
    for (int j=0;j<3;j++)
    if (altura[crianca[c].x+dx[i]][crianca[c].y+dy[j]] < 9 and c_livre(crianca[c].x+dx[i],crianca[c].y+dy[j])) {
            sprintf(movimento[c],"drop %d %d\n",crianca[c].x+dx[i],crianca[c].y+dy[j]);
            return true;
    }

    return corre(c,rand()%31,rand()%31);
}



bool monta_boneco(int c) {
    int xalvo = crianca[c].x-1, yalvo = crianca[c].y;

    // se em peh e segurando nada, agacha!
    if (crianca[c].empe and crianca[c].mao == M_VAZIA) { sprintf(movimento[c],"crouch\n"); return true; }

    // se o campo-alvo ta vazio, presciso pegar 3 neves!
    if (campo[xalvo][yalvo] == C_VAZIO) {
        if (crianca[c].mao == M_VAZIA or crianca[c].mao == M_1NEVE or crianca[c].mao == M_2NEVE) {
            peganevesolta(c);
            return true;
        }
        // se ja tenho a neve, faz a bola!
        if (crianca[c].mao == M_3NEVE) { sprintf(movimento[c],"crush\n"); return true; }
        // ja tenho as bola, e to em pe, poe!
        sprintf(movimento[c],"drop %d %d\n",xalvo,yalvo);
        return true;
    }

    // se o campo-alvo tem 1 grande ou ta emiplado errado, presciso pegar 2 neves!
    if (campo[xalvo][yalvo] == C_BGRANDE or campo[xalvo][yalvo] == C_BPQUENA_BGRANDE or campo[xalvo][yalvo] == C_BPEQUENA) {
        if (crianca[c].mao == M_VAZIA or crianca[c].mao == M_1NEVE) {
            peganevesolta(c);
            return true;
        }
        // se ja tenho a neve, faz a bola!
        if (crianca[c].mao == M_2NEVE) { sprintf(movimento[c],"crush\n"); return true; }
        // ja tenho as bolas , poe!
        sprintf(movimento[c],"drop %d %d\n",xalvo,yalvo);
        return true;
    }

    // se o campo-alvo tem 1 grande e uma media, presciso pegar 1 neve!
    if (campo[xalvo][yalvo] == C_BMEDIA_BGRANDE) {

        if (crianca[c].mao == M_VAZIA) {
            peganevesolta(c);
            return true;
        }
        // se ja tenho a neve, faz a bola!
        if (crianca[c].mao == M_1NEVE) { sprintf(movimento[c],"crush\n"); return true; }
        // ja tenho as bolas , poe !
        sprintf(movimento[c],"drop %d %d\n",xalvo,yalvo);
        return true;
    }

    return false;
}

bool ataca(int c) {

    int olddist;
    // axa a crianca ameacadora mais perto;
    bool forcacatch=false;
    int x = TIME, dist = 0x3f3f3f3f, y = TIME;
    for (int i=TIME;i<2*TIME;i++) if (crianca[i].x != SEILA) {
        int dist2 = (crianca[i].x - crianca[c].x)*(crianca[i].x - crianca[c].x) + (crianca[i].y-crianca[c].y)*(crianca[i].y-crianca[c].y);
        if (dist2 < dist) { dist = dist2; x = i; }

        //se alguma tiver dsit < 8 , nao tonta, bola na mao, antivini < 3 e cabe na minha, forca catch!
        if (M_1BPEQ <= crianca[i].mao and crianca[i].mao <= M_3BPEQ and dist2 < 8*8 and crianca[i].tontura == 0 and antivini[c] < 3 and (crianca[c].mao == M_VAZIA or crianca[c].mao == M_1BPEQ or crianca[c].mao == M_2BPEQ)) {
            forcacatch=true;
            y = i;
        }
    }

    // se ela ta nao-tonta, com bola na mao e ainda cabe na minha, tenta pegar a bola dela >:)
    // mas soh se antivini[c] < 3!
    if (forcacatch) {
        sprintf(movimento[c],"catch %d %d\n",crianca[y].x,crianca[y].y);
        antivininow[c] = 1;
        return true;
    }

    // se axei e ta tonta, axa outra, deixando o msm alvo caso nao axar
    if (dist != 0x3f3f3f3f and crianca[x].tontura > 0) {
        olddist = dist;
        dist = 0x3f3f3f3f;
        for (int i=TIME;i<2*TIME;i++) if (crianca[i].x != SEILA and crianca[i].tontura == 0) {
            int dist2 = (crianca[i].x - crianca[c].x)*(crianca[i].x - crianca[c].x) + (crianca[i].y-crianca[c].y)*(crianca[i].y-crianca[c].y);
            if (dist2 < dist) { dist = dist2; x = i; }
        }
        if (dist == 0x3f3f3f3f) dist = olddist;
    }

    // se nao tem bola, tenta montar uma bola
    if (crianca[c].empe and crianca[c].mao == M_VAZIA) { sprintf(movimento[c],"crouch\n"); return true; }
    if (crianca[c].mao == M_VAZIA) return peganevesolta(c);
    if (crianca[c].mao == M_1NEVE) { sprintf(movimento[c],"crush\n"); return true; }
    if (crianca[c].mao == M_1BPEQ and !crianca[c].empe) { sprintf(movimento[c],"stand\n"); return true; }


    // se nao tem alvo, corre pra (aleatorio,aleatorio)
    if (dist == 0x3f3f3f3f) { return corre(c,rand()%31,rand()%31); }

    // se tem mas ta um pokinh longe, corre pra la
    if (dist >= 8*8) return corre(c,crianca[x].x, crianca[x].y);

    // se eu ja tenho bola na mao, ataca!
    if (crianca[c].mao == M_1BPEQ or crianca[c].mao == M_2BPEQ or crianca[c].mao == M_3BPEQ) {
        int dx = crianca[x].x - crianca[c].x;
        int dy = crianca[x].y - crianca[c].y;
        // atira se o caminho tiver livre; se nao, chega mais perto!
        if (caminho_livre(crianca[c].x,crianca[c].y,crianca[x].x, crianca[x].y))
            sprintf(movimento[c],"throw %d %d\n",crianca[c].x+3*dx, crianca[c].y+3*dy);
        else return corre(c,crianca[x].x, crianca[x].y);
        // ignora pra nao dar conflito de bola
        crianca[x].x = crianca[x].y = SEILA;
        return true;
    }


    return false;
}


// crianca c destroi boneco em xd, yd
bool destroi(int c,int xd, int yd) {

   fprintf(stderr,">>> crianca %d para %d,%d\n",c,xd,yd);

    // ve se tem crianca nao tonta com bola na mao
    bool temcrianca = false;
    int x = crianca[c].x, y = crianca[c].y;
    for (int i=TIME;i<2*TIME;i++) if (crianca[i].x != SEILA and crianca[i].tontura == 0 and M_1BPEQ <= crianca[i].mao and crianca[i].mao <= M_3BPEQ) {
        int dist2 = (crianca[i].x - x)*(crianca[i].x - x) + (crianca[i].y-y)*(crianca[i].y-y);
        if (dist2 < 8*8) { temcrianca = true; break; }
    }
    // se tem crianca, ataca
    if (temcrianca) return ataca(c);

     //bonecomal[x].x = bonecomal[x].y = SEILA;
    // comentado pq isso qm faz eh o definebonecos


    // ve se ta adjacente
    bool adj = false;
    for (int i=-1;i<=1;i++)
    for (int j=-1;j<=1;j++)
        if (xd == crianca[c].x + i and yd == crianca[c].y + j) adj = true;

    if (!adj) {if (!crianca[c].empe) { sprintf(movimento[c],"stand\n"); return true;} else return corre(c,xd,yd); }
    if (crianca[c].mao != M_VAZIA) return largamao(c);
    if (crianca[c].empe)
        sprintf(movimento[c],"crouch\n");
    else {
        sprintf(movimento[c],"pickup %d %d\n",xd,yd);
        forcapoe[c] = true;
    }
    return true;
}

void definebonecos() {
    for (int i=0;i<nboqs;i++) {
        //axa crianca mais perto do boneco
        int dist = 0x3f3f3f3f, cri = 0;
        for (int c = 0;c<TIME;c++) {
            int d = (crianca[c].x - bonecomal[i].x)*(crianca[c].x - bonecomal[i].x) +
                    (crianca[c].y - bonecomal[i].y)*(crianca[c].y - bonecomal[i].y);
            if (d < dist and movimento[c][0] == '\0') { dist = d; cri = c;}
        }
        //crianca cri ataca!
        destroi(cri, bonecomal[i].x, bonecomal[i].y);
    }
}

int main() {

    memset(forcapoe,false,sizeof(forcapoe));
    memset(antivini,0,sizeof(antivini));
    memset(antivininow,0,sizeof(antivininow));

    srand(time(NULL));
  int turnNum;
  while ( scanf(" %d ",&turnNum) and turnNum >= 0) {
    memset(antivininow,0,sizeof(antivininow));
    nboqs=0;
    // Read the current score.
    scanf("%d %d",&score[0],&score[1]);

    // Read the state of the field.
    for ( int i = 0; i < TAM; i++ ) {
      for ( int j = 0; j < TAM; j++ ) {
        char a, b;
        scanf(" %c%c ",&a,&b);
        if ( a != '*' ) {
            altura[i][j] = a-'0';
            campo[i][j] = b;
        } else {
            altura[i][j] = campo[i][j] = SEILA;
        }
        if (campo[i][j] == C_BONECO_DELE) {
            bonecomal[nboqs].x = i;
            bonecomal[nboqs].y = j;
            nboqs++;
        }
      }
    }
    char token[32];
    for ( int i = 0; i < 2*TIME; i++ ) {
      scanf("%s",token);
      if ( token[0] == '*' ) {
          crianca[i].x = crianca[i].y = SEILA;
      } else {
        crianca[i].x = atoi(token);
        scanf("%d",&(crianca[i].y));

        char ch;
        scanf(" %c ",&ch);
        crianca[i].empe = (ch == 'S');
        scanf(" %c ",&(crianca[i].mao));
        scanf("%d",&(crianca[i].tontura));
      }
    }


    memset(podepegar,true,sizeof(podepegar));

    for (int i=0;i<TIME;i++) {
        // se ta forcado pra por, poe!
        if (forcapoe[i]) {
            for (int k=-1;k<=1;k++)
            for (int l=-1;l<=1;l++)
            if (campo[crianca[i].x+k][crianca[i].y+l] == C_BMEDIA_BGRANDE) {
                sprintf(movimento[i],"drop %d %d\n",crianca[i].x+k,crianca[i].y+l);
                break;
            }
            forcapoe[i] = false;
            continue;
        // se nao, 'esvazia'movimento
        } else
            movimento[i][0] = '\0';
    }

    definebonecos();

    for (int i = 0;i<TIME;i++) {
        // se ja tem movimento, entao tah!
        if (movimento[i][0] != '\0') continue;

        sprintf(movimento[i],"idle\n");
        // se ta tonta, fazer o q ne =/
        if (crianca[i].tontura > 0) { sprintf(movimento[i],"idle\n"); continue; }
        int posx, posy;
        posx = 8+16*(i/2); posy = 8+16*(i%2);

       // se to em territorio inimigo, atacar!
        if (territorio_inimigo(crianca[i].x,crianca[i].y) and ataca(i)) continue;

        // se nao tem boneco meu em (posx-1,posy)
        if (campo[posx-1][posy] != C_BONECO_MEU) {
            if (crianca[i].x != posx or crianca[i].y != posy) {
                // tenta correr pra (posx, posy)
                if (!corre(i,posx,posy)) { sprintf(movimento[i],"idle\n"); }
            } else {
                // ja to na posicao, monta boneco =)
                if (!monta_boneco(i)) { sprintf(movimento[i],"idle\n");}
            }
        } else {
            // tem boneco meu ja, ataca!
            if (!ataca(i)) { sprintf(movimento[i],"idle\n"); }
        }

    }

    //atualiza antivini
    for (int i=0;i<TIME;i++)
        if (antivininow[i] == 0) antivini[i] = 0;
        else antivini[i]++;

    //imprime movimentos
    //fprintf(stderr,"[[%d]]\n",turnNum);
    for (int i=0;i<TIME;i++) {
        printf("%s",movimento[i]);
        //fprintf(stderr,"%d -> [av = %d, empe = %d ] %s",i,antivini[i],crianca[i].empe, movimento[i]);
    }

    fflush(stdout);
  }
}
